#ifndef _ASPI_I_H
#define _ASPI_I_H

typedef struct
{
	unsigned char devType;
	char reserved1[7];
	char Vendor[24];
} InquiryS;


typedef struct
{
	unsigned char res;
	unsigned char adr;
	unsigned char trackNr;
	unsigned char reserved;
	unsigned long addr;
/*
	unsigned char addrM3;
	unsigned char addrM2;
	unsigned char addrM1;
	unsigned char addrM0;
*/
} TOCEntryS;

typedef struct
{
	unsigned char lenM;
	unsigned char lenL;
	unsigned char first;
	unsigned char last;
	TOCEntryS tracks[100];
} TOCdataS;

typedef struct
{
	unsigned char adapter;
	unsigned char target;
	unsigned char lun;
	char cdromsA[10][25];
	unsigned char cdrCa[20];
	unsigned char cdrCt[20];
	unsigned char cdrCl[20];
	unsigned char cdromsC;
	unsigned char adapterT;
	unsigned char targetT;
	unsigned char lunT;
	unsigned char dataOK;
	TOCdataS myTOC;
} CdrConfS;

/* max scsi target id */
#define MAX_ID           		8

/* ASPI SRB packet length */
#define ASPI_SRB_LEN			0x100

/* inquiry buffer length */
#define INQUIRY_BUFFER_LENGTH 	0x20

/* data transfer length for reads */
#define DATA_BUFFER_LENGTH		0x10000

/* disk sector size */
#define DISK_SEC_SIZE  			0x200

/* disk sector size */
#define CDROM_SEC_SIZE  		2340

/* maximum start block */
#define HIGH_BLOCK_START		0x4000
#define BLOCK_INCREMENT			0x80

#endif // _ASPI_I_H