#include <windows.h>

#include "type.h"
#include "cd.h"
#include "Win32Def.h"
#include "resource.h"

#define VERSION     0x0100  // Version must be in BCD format

// From ASPIcfg.c
int EnumerateCD(HWND hwnd);
int GetCode(int pos);
void SetToCombo(HWND hwnd);

static FPSEWin32About info = {
    FPSE_CDROM,
    VERSION & 0xFF,
    VERSION >> 8,
    0,
    "LDChen",
    "CDAspi",
    "This Plugin uses ASPI for reading CDs.\x00d\x00a\x00d\x00a"
    "You must be sure that ASPI driver is correctly installed "
    "in your system.\x00d\x00a\x00d\x00a"
    "You can get the newest ASPI driver at:\x00d\x00a"
    "ftp://ftp.adaptec.com\x00d\x00a"
};

static HANDLE     hinstance = (HANDLE)-1;
static FPSEWin32 *infocfg;

BOOL WINAPI
#ifdef __GNUC__
LibMain
#else
DllMain
#endif
(HANDLE hInstance, DWORD fdwReason, PVOID fImpLoad)
{
    hinstance = hInstance;
    return TRUE;
}


BOOL CALLBACK ConfigDialogProc(HWND hwnd, UINT msg, WPARAM wPar, LPARAM lPar)
{
    switch (msg) {
    case WM_INITDIALOG:
        EnumerateCD(hwnd);
        SetToCombo(hwnd);
        return TRUE;

    case WM_DESTROY:
        EndDialog(hwnd,0);
        return TRUE;

    case WM_COMMAND:
        switch (wPar) {
        case IDOK:
        {
            char buf[4];
            int pos = SendMessage((HWND)GetDlgItem(hwnd,IDC_COMBODRIVES),
                                  CB_GETCURSEL,0,0L);
            pos = GetCode(pos);
            *(UINT32 *)(buf) = 0;
            buf[0] = (pos & 0xFF) + '0';
            infocfg->WriteCfg("CDASPI","AdapterID",buf);
            buf[0] = (pos >> 8) + '0';
            infocfg->WriteCfg("CDASPI","TargetID",buf);
        }
        case IDCANCEL:
            EndDialog(hwnd,0);
            return TRUE;
        }
    }

    return FALSE;
}

int CD_Configure(UINT32 *par)
{
    infocfg = (FPSEWin32 *)par;

    DialogBox(hinstance,MAKEINTRESOURCE(IDD_DIALOG),
              infocfg->HWnd,ConfigDialogProc);
    return FPSE_OK;
}

void CD_About(UINT32 *par)
{
    memcpy( par, &info, sizeof(FPSEWin32About) );
}
